﻿import { EventEmitter} from '@angular/core';

export abstract class BaseComponent {
    //Hold references to the subscriptions
    observers: any[];

    /**
     * Constructor
     */
    constructor() {
        this.observers = [];
    }

    /**
     * Subscribe the event with callback
     * @param event
     * @param callback
     */
    subscribeEvent(event: EventEmitter<any>, callback) {

        let ref = event.subscribe(data => {
            callback(data);
        });
        this.observers.push(ref);
    }

    /**
     * Releases the resources
     */
    cleanUp() {
        this.observers.forEach((item, i, arr) => {
            item.unsubscribe();
        });
    }
}