﻿import { AcquisitionStepModel, AcquisitionGroupModel } from './acquisitionGroup.model'

/**
 * This class holds order specific data
 */
export class OrderData {
    MachineDesc: string;
    MachineNo: string;
    AcquisitionStatus: number;
    NextInspectionDate: string;
    NextPartNo: string;
    PartDesc: string;
    PartNo: string;
    SchemaName: string;
    InspectionOrderNo: string;
    InspectionOrderID: number;
    InspectionOrderSequence: number;
    InspectionPlanDesc: string;
    InspectionPlanNo: string;
    CreationDate: string;
    LotInfo: string;
    OperatorName: string;
}

/**
 * This class hold all the data components required to display
 */
export class CompleteStepData {
    constructor(
        public step: AcquisitionStepModel,
        public order: OrderData,
        public group: AcquisitionGroupModel
    ) { }
}

/**
 * This enum holds type of tolerence limit.
 */
export enum TolerenceType {
    Absolute = 1,
    Relative
}

/**
 * Represents acquisition completion result.
 */
export class AcquisitionCompletionResult {
    isComplete: boolean;
    emptyParentRowIndex: number;

    constructor() {
        this.isComplete = false;
        this.emptyParentRowIndex = -1;
    }
}