﻿import { Injectable } from '@angular/core'

@Injectable()
export class HtmlCreationService {

    /**
     * Creates HTML for VAR.
     * @param ul
     * @param ll
     * @param val
     * @param nominalVal
     * @param margin
     * @param minLineWidth
     * @param marginTopLine
     */
    createVARHtml(ul: number, ll: number, val: number, nominalVal: number, margin: number, minLineWidth: number, marginTopLine: number): string {
        let varHtmlStr = "";
        if (null == val) {
            varHtmlStr = "<div class='line-color-notdone'></div>"
        } else {
            var width: number;
            var marginLeft: number;
            var marginRight: number;
            var leftVert: string = "";
            var rightVert: string = "";
            let ll1: number;
            let ul1: number;
            //If LT < UT < NV (left sided)
            if (nominalVal > ul && ul != null) {
                //Find the scale
                let scale = ((nominalVal - ll) / (100 - 2 * margin));
                ll1 = ll - scale * margin;
                ul1 = nominalVal + scale * margin;
                leftVert = "<div class='leftVert' style ='margin-left:" + margin.toString() + "%" + "'></div>";
                marginLeft = (ul - ll) / scale;
                rightVert = "<div class='rightVert' style ='margin-left:" + marginLeft.toString() + "%'></div>";
                //calculate margins for line
                marginRight = margin;
                if (val > ul1) {
                    //limit the width till ul1
                    width = (ul1 - nominalVal) / scale;
                    marginLeft = (nominalVal - ul) / scale;
                }
                else {
                    width = (nominalVal - val) / scale;
                    marginLeft = (nominalVal - ul) / scale - width - minLineWidth / 2;
                }

                if (Math.abs(width) < minLineWidth) {
                    width = minLineWidth;
                }

            }
            //If NV < LT < UT (Right sided)
            else if (nominalVal < ll) {
                let scale = ((ul - nominalVal) / (100 - 2 * margin));
                ll1 = nominalVal - scale * margin;
                ul1 = ul + scale * margin;
                marginRight = (ul - ll) / scale ;
                if (val >= ll1 && val < nominalVal) {
                    //limit the width till ul1
                    width = (nominalVal - val) / scale;
                    marginLeft = margin - width;
                    let leftVertMargin = (ll - nominalVal) / scale ;
                    leftVert = "<div class='leftVert' style ='margin-left:" + leftVertMargin.toString() + "%;margin-right:" + marginRight.toString() + "%'></div>";
                }
                else if (val < ll1) {
                    //limit the width till ul1
                    width = margin;
                    marginLeft = 0;
                    let leftVertMargin = (ll - nominalVal) / scale + minLineWidth / 2;
                    leftVert = "<div class='leftVert' style ='margin-left:" + leftVertMargin.toString() + "%;margin-right:" + marginRight.toString() + "%'></div>";
                }
                else {
                    width = (val - nominalVal) / scale;
                    marginLeft = (ll - nominalVal) / scale - width - minLineWidth / 2;
                    leftVert = "<div class='leftVert' style ='margin-left:" + marginLeft.toString() + "%;margin-right:" + marginRight.toString() + "%'></div>";
                    //calculate margins for line
                    marginLeft = margin + minLineWidth / 2;
                }
                marginRight = 0;
               
                rightVert = "<div class='rightVert'></div>";
                if (Math.abs(width) < minLineWidth) {
                    width = minLineWidth;
                }
                

            }
            //If LT < NV < UT (Two sided)
            else {
                if (ll != null) {
                    leftVert = "<div class='leftVert' style ='margin-left:" + margin.toString() + "%" + "'></div>";
                    ll1 = ll - ((nominalVal - ll) / (50 - margin)) * margin;
                }
                else {
                    ll1 = nominalVal - ((ul - nominalVal) / (50 - margin)) * 50;
                }
                if (ul != null) {
                    rightVert = "<div class='rightVert'></div>";
                    if (ll != null) {
                        ul1 = ul + ((ul - nominalVal) / (50 - margin)) * margin;
                    }
                    else {
                        ul1 = ul + ((ul - nominalVal) / 40) * 10;
                    }
                }
                else {
                    ul1 = nominalVal + (nominalVal - ll1);

                }

                if (nominalVal == val) {
                    marginLeft = 50 - margin - minLineWidth / 2;
                    if (ll != null) {
                        marginRight = marginLeft;
                    }
                    else {
                        marginRight = 40;
                    }
                    width = minLineWidth;
                }
                else if (val == ll) {
                    width = 50 - margin;
                    marginLeft = 0;
                    marginRight = 50 - margin;
                }
                else if (val == ul) {
                    marginLeft = 50 - margin;
                    marginRight = 0;
                    if (ll != null) {
                        width = 50 - margin;
                    }
                    else {
                        width = 40;
                    }
                }
                else if ((ll1 < val) && (val < nominalVal)) {
                    width = 50 * (nominalVal - val) / (nominalVal - ll1);
                    marginLeft = 50 - margin - width;
                    if (ll != null) {
                        marginRight = 50 - margin;
                    }
                    else {
                        marginRight = 40;
                    }
                }
                else if ((nominalVal < val) && (val < ul1)) {
                    width = 50 * (val - nominalVal) / (ul1 - nominalVal);
                    marginLeft = 50 - margin;
                    if (ll != null) {
                        marginRight = 50 - margin - width;
                    }
                    else {
                        marginRight = 40 - width;
                    }
                }
                else if (val < ll1 || val == ll1) {
                    width = 51;
                    marginLeft = - margin - 1;
                    if (ll != null) {
                        marginRight = 50 - margin;
                    }
                    else {
                        marginRight = 40;
                    }
                }
                else if (val > ul1 || val == ul1) {
                    width = 50;
                    marginLeft = 50 - margin;
                    if (ll != null) {
                        marginRight = - margin;
                    }
                    else {
                        marginRight = -10;
                    }

                }
                if (ll == null) {
                    if (val > nominalVal)
                        marginLeft = 50;
                    else
                        marginRight = 40;

                }
                //keep min margins & width(i.e. same as nominalVal == val case)  if calculated width is less than minimum width
                if (width < minLineWidth) {
                    marginLeft = 50 - margin - minLineWidth / 2;
                    marginRight = marginLeft;
                    width = minLineWidth;
                }
            }
            var line: string = this.getVarHtmlLine(ul, ll, nominalVal, val, width, marginLeft, marginRight, marginTopLine);
            if (nominalVal < ll) {
                varHtmlStr = line + leftVert + rightVert;
            }
            else if (nominalVal > ul) {
                varHtmlStr = leftVert + rightVert + line;

            }
            else {
                varHtmlStr = leftVert + line + rightVert;
            }
        }
        return varHtmlStr;
    }

    /**
     * Sets HTML for VAR.
     * @param ul
     * @param ll
     * @param nominalVal
     * @param val
     * @param width
     * @param marginLeft
     * @param marginRight
     * @param marginTop
     */
    private getVarHtmlLine(ul: number, ll: number, nominalVal: number, val: number, width: number, marginLeft: number, marginRight: number, marginTop: number): string {
        var line: string;
        if ((ul == null) && (val >= ll)
            || (ll == null) && (val <= ul)
            || (ll <= val && ul >= val)
        ) {
            line = "<div class='limitOKLine' style='width:" + width.toString() + "%;margin-left:" + marginLeft.toString() + "%;margin-right:" + marginRight.toString() + "%;margin-top:" + marginTop.toString() + "%'></div>";
        }

        else {
            line = "<div class='limitDangerLine' style='width:" + width.toString() + "%;margin-left:" + marginLeft.toString() + "%;margin-right:" + marginRight.toString() + "%;margin-top:" + marginTop.toString() + "%'></div>";
        }
        return line;
    }

    /**
     * Returns default VAR html span
     * @param minLineWidth
     * @param margin
     * @param ut
     * @param lt
     * @param nominalVal
     */
    getDefaultVARLine(minLineWidth: number, margin: number, ut: number, lt: number, nominalVal: number): string {
        let marginLeft: number;
        let marginRight: number;
        let leftVert: string = "";
        let rightVert: string = "";
        // if  NV <LT < UT
        if (nominalVal < lt) {
            marginLeft = 50 - margin - minLineWidth / 2;
            marginRight = marginLeft;
            let lineOk: string = "<div class='limitOKLine' style='width:" + minLineWidth.toString() + "%;margin-left:" + margin.toString() + "%'></div>";
            leftVert = "<div class='leftVert' style ='margin-left:" + marginLeft.toString() + "%;margin-right:" + marginRight.toString() + "%'></div>";
            rightVert = "<div class='rightVert'></div>";
            let varHtmlStr = "<span style='display: -webkit-box'>" + lineOk + leftVert + rightVert + "</span>";
            return varHtmlStr;
        }

        // if  NV > UT > LT
        else if (nominalVal > lt && nominalVal > ut && ut != null) {
            marginLeft = 50 - margin - minLineWidth / 2;
            marginRight = marginLeft;
            leftVert = "<div class='leftVert' style ='margin-left:" + margin.toString() + "%" + "'></div>";
            rightVert = "<div class='rightVert' style ='margin-left:" + marginLeft.toString() + "%;margin-right:" + marginRight.toString() + "%'></div>";
            let lineOk: string = "<div class='limitOKLine' style='width:" + minLineWidth.toString() + "%'></div>";
            let varHtmlStr = "<span style='display: -webkit-box'>" + leftVert + rightVert + lineOk + "</span>";
            return varHtmlStr;
        }
        //If LT < NV < UT
        else {
            if (lt != null) {
                marginLeft = 50 - margin - minLineWidth / 2;
                marginRight = marginLeft;
            }
            else {
                marginLeft = 50 - minLineWidth / 2;
                marginRight = 40 - minLineWidth / 2;
            }
            let lineOk: string = "<div class='limitOKLine' style='width:" + minLineWidth.toString() + "%;margin-left:" + marginLeft.toString() + "%;margin-right:" + marginRight.toString() + "%'></div>";
            if (lt != null) {
                leftVert = "<div class='leftVert' style ='margin-left:" + margin.toString() + "%" + "'></div>";
            }
            if (ut != null) {
                rightVert = "<div class='rightVert'></div>";
            }
            let varHtmlStr = "<span style='display: -webkit-box'>" + leftVert + lineOk + rightVert + "</span>";
            return varHtmlStr;
        }
    }
}
