﻿import { Component, Input, Output, ElementRef, ViewChild, EventEmitter } from '@angular/core';

import { BaseComponent } from '../baseComponent'

declare var $: JQueryStatic;
@Component({
    selector: 'att-table',
    template: '<div #att id="{{id}}" style="display:none"> </div>',
    //properties: ['id: id'],
    //providers: [AcquisitionGroupService],
    //providers:[IteratorService, AcquisitionTableUpdateService]
})

export class AttTableComponent extends BaseComponent {
    @ViewChild('att') el: ElementRef;
    @Input() id: string;
    @Input('maxDecimalVal') maxVal: number;
    @Input() source;
    @Input('data') tableData: any;

    @Output('change') parentChange = new EventEmitter();
    @Output('move') moveToNextTable = new EventEmitter();


    selectedUiObj: any;
    selectedRowId: number;

    constructor(public element: ElementRef) {
        super();
        this.selectedRowId = undefined;
        this.selectedUiObj = undefined;
    }
    ngOnInit() {
        let that = this;
        this.createChildTable();
        console.log(this.tableData);
    }
    public showEditMode() {
        //document.getElementById(this.id).style.display = "block";
        console.log("IN edit mode for ATT");
        setTimeout(() => {
            var widget = $(this.el.nativeElement).igGrid("widget");
            this.startEdit(widget, 1);
        }, 500);
    }
    private startEdit(childGrid, childRowId: number) {
        var isEditing = childGrid.igGridUpdating("isEditing");
        if (isEditing) {
            childGrid.igGridUpdating("endEdit", true, false);
        }
        childGrid.igGridUpdating("startEdit", childRowId, "NIO", true);
    }
   
    private createChildTable() {
                let name = "#" + this.id;
        let that = this;
        console.log("Att Grid ID " + name);
        $(this.el.nativeElement).igGrid({
            key: "AcquisitionSteps",
            autoCommit: false,
            dataSource: this.source,
            width: "100%",
            primaryKey: "UniqueID",
            //foreignKey: "GroupIndex",
            autoGenerateColumns: false,
            autoGenerateColumnLayouts: false,
            autofitLastColumn: false,
            alternateRowStyles: true,
            columns: [
                { key: "UniqueID", dataType: "number", hidden: true },
                { key: "ChartValue", headerText: "", width: "10%", dataType: "string" },
                { key: "AcquisitionStepNoInGroup", headerText: "#", width: "5%", dataType: "number" },
                { key: "Description", headerText: "DESCRIPTION", width: "20%", dataType: "string" },
                { key: "AmountOfParts", headerText: "Parts", width: "5%", dataType: "number" },
                { key: "IO", headerText: "IO", width: "5%", dataType: "number" },
                { key: "NIO", headerText: "NIO", width: "5%", dataType: "number", columnCssClass: "acqtype-column-val" },
                { key: "PropertyNo", headerText: "ACQUISITION STEP NR.", width: "9%", dataType: "string" }
            ],
            features: [
                {
                    name: "Updating", startEditTriggers: 'enter,click', enableAddRow: false, editMode: "row", enableDeleteRow: false,
                    showDoneCancelButtons: false, wrapAround: false,
                    editCellStarted: function (evt, ui) {
                        that.selectedUiObj = ui;
                        that.selectedRowId = ui.rowID;

                    },
                    editCellEnded: function (evt, ui) {  },
                    columnSettings: [
                        { columnKey: "UniqueID", editorType: "numeric", readOnly: true },
                        { columnKey: "ChartValue", editorType: "string", readOnly: true },
                        { columnKey: "AcquisitionStepNoInGroup", readOnly: true },
                        { columnKey: "Description", editorType: "string", readOnly: true },
                        { columnKey: "AmountOfParts", editorType: "numeric", readOnly: true },
                        { columnKey: "IO", editorType: "numeric", readOnly: true },
                        {
                            columnKey: "NIO", editorOptions: {
                                validation: true,
                                textChanged: function (evt, ui) { // Text changed is thrown for every change in value.
                                    console.log('Text changed : ' + ui.text);
                                    ui.owner.options.maxDecimals = that.maxVal;
                                    ui.owner.options.minDecimals = that.maxVal;
                                    //that.acquisitionGroupService.syncStep(selectedStep, val);
                                    return true;
                                }
                            },
                            editorType: "numeric", readOnly: false
                        },
                        { columnKey: "PropertyNo", editorType: "string", readOnly: true }]
                }
            ],
            rendered: function (evt, ui) {
                console.log("----------------rendered------------------");
                //document.getElementById(that.id).style.display = "block";
            }
        });
    }
    
}