﻿import { Component, Input, Output, ElementRef, ViewChild, EventEmitter } from '@angular/core';

import { BaseComponent } from '../baseComponent'

declare var $: JQueryStatic;
@Component({
    selector: 'var-table',
    template: '<div #var id="{{id}}" style="display:none"> </div>',
    //properties: ['id: id'],
    //providers: [AcquisitionGroupService],
    //providers:[IteratorService, AcquisitionTableUpdateService]
})

export class VarTableComponent extends BaseComponent {
    @ViewChild('var') el: ElementRef;
    @Input() id: string;
    @Input('maxDecimalVal') maxVal: number;
    @Input() source;
    @Input('data') tableData: any;

    @Output('change') parentChange = new EventEmitter();
    @Output('move') moveToNextTable = new EventEmitter();

    selectedUiObj: any;
    selectedRowId: number;

    constructor(public element: ElementRef) {
        super();
        this.selectedRowId = undefined;
        this.selectedUiObj = undefined;
    }
    ngOnInit() {
        let that = this;
        this.createChildTable();
        console.log(this.tableData);
        setTimeout(() => {

            //$(this.el.nativeElement).on("iggridupdatingeditcellstarted", function (evnt, ui) {
            //    that.selectedUiObj = ui;
            //    that.selectedRowId = ui.rowID;
            //});
        }, 1000);
    }
    public showEditMode() {
        //document.getElementById(this.id).hidden = false;
        //document.getElementById(this.id).style.display = "block";
        console.log("IN edit mode for VAR");
        setTimeout(() => {
            var widget = $(this.el.nativeElement).igGrid("widget");
            this.startEdit(widget, 1);
        }, 500);
    }
    private startEdit(childGrid, childRowId: number) {
        var isEditing = childGrid.igGridUpdating("isEditing");
        if (isEditing) {
            childGrid.igGridUpdating("endEdit", true, false);
        }
        childGrid.igGridUpdating("startEdit", childRowId, "ACQValue", true);
    }
    private createChildTable() {
        let that = this;
       
        $(this.el.nativeElement).igGrid({
            key: "AcquisitionSteps",
            autoCommit: false,
            dataSource: this.source,
            width: "100%",
            primaryKey: "UniqueID",
            //foreignKey: "GroupIndex",
            autoGenerateColumns: false,
            autoGenerateColumnLayouts: false,
            autofitLastColumn: false,
            alternateRowStyles: true,
            columns: [
                { key: "UniqueID", dataType: "number", hidden: true },
                { key: "ChartValue", headerText: "", width: "10%", dataType: "string" },
                { key: "AcquisitionStepNoInGroup", headerText: "#", width: "5%", dataType: "number" },
                { key: "PartNo", headerText: "PART", width: "4%", dataType: "number" },
                { key: "ToolID", headerText: "TOOL", width: "4%", dataType: "number" },
                { key: "DecimalPlaces", headerText: "Decimals", width: "1%", dataType: "number", hidden: true },
                { key: "LowerTolerance", headerText: "LT", width: "6%", dataType: "number" },
                { key: "NominalValue", headerText: "NOMINAL VALUE", width: "10%", dataType: "number" },
                { key: "UpperTolerance", headerText: "UT", width: "6%", dataType: "number" },
                { key: "ACQValue", headerText: "VALUE", width: "7%", dataType: "number", columnCssClass: "acqtype-column-val" },
                { key: "VarDescription", headerText: "DESCRIPTION", width: "10%", dataType: "string" },
                { key: "PropertyNo", headerText: "ACQUISITION STEP NR.", width: "9%", dataType: "string" }
            ],
            features: [
                        {
                name: "Updating", startEditTriggers: 'enter,click', enableAddRow: false, editMode: "row", enableDeleteRow: false,
                showDoneCancelButtons: false, wrapAround: false,
                editCellStarted: function (evt, ui) {
                    that.selectedUiObj = ui;
                    that.selectedRowId = ui.rowID;

                },
                editCellEnded: function (evt, ui) {  },
                columnSettings: [
                    { columnKey: "UniqueID", editorType: "numeric", readOnly: true },
                    { columnKey: "ChartValue", editorType: "string", readOnly: true },
                    { columnKey: "AcquisitionStepNoInGroup", readOnly: true },
                    { columnKey: "PartNo", editorType: "numeric", readOnly: true },
                    { columnKey: "ToolID", editorType: "numeric", readOnly: true },
                    { columnKey: "LowerTolerance", editorType: "numeric", readOnly: true },
                    { columnKey: "NominalValue", editorType: "numeric", readOnly: true },
                    { columnKey: "UpperTolerance", editorType: "numeric", readOnly: true },
                    {
                        columnKey: "ACQValue", editorOptions: {
                            validation: true,
                            textChanged: function (evt, ui) { // Text changed is thrown for every change in value.
                                console.log('Text changed : ' + ui.text);
                                ui.owner.options.maxDecimals = that.maxVal;
                                ui.owner.options.minDecimals = that.maxVal;
                                
                                return true;
                            }
                        },
                        editorType: "numeric", readOnly: false
                    },
                    { columnKey: "VarDescription", readOnly: true },
                    { columnKey: "PropertyNo", editorType: "string", readOnly: true }]
                },
                {
                    name: "Selection",
                    mode: "row",
                    activation: true,
                    persist: true
                }
            ],
            rendered: function (evt, ui) {
                //document.getElementById(that.id).style.display = "block";
                console.log("----------------rendered------------------");
            }
        });
    }
}